<%-- 
    Document   : gameboard
    Created on : Apr 2, 2008, 1:57:05 PM
    Author     : arungupta
--%>

<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>

<script type="text/javascript">
    var XorO;
    var imagesPrefix = '/ttt-java/images/';
    var winner = '<h1>We have a winner!!!</h1>';
    
    function getXHR() {
        if (window.XMLHttpRequest) {
            return new XMLHttpRequest();
        } else if (window.ActiveXObject) {
            return new ActiveXObject("Microsoft.XMLHTTP");
        }
        return null;
    };
        
    this.submitForm = function(args) {
        if (document.images[args.name].src != "http://localhost:8080" + imagesPrefix + "blank.png")
            return;
        
        setXorO();
        updateBoard({ position: args.name, imageLoc: XorO });
        request = this.getXHR();
        url="http://localhost:8080/ttt-java/tictactoe?position=" + args.name + "&imageLoc=" + XorO;
        request.open("POST", url, false);
        request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        request.onreadystatechange = function() {
            if (request.readyState == 4) {
                if (request.status == 200) {
                    if (request.responseText) {
                        // TODO: Winner in both contexts should be notified using Comet.
                        // TODO: This is only a workaround.
                        if (request.responseText == "X" || request.responseText == "O") {
                            reportWinner("<img src='" + imagesPrefix + request.responseText + ".png'> <font size='+10'>won!!!</font>");
                        }
                        updatePage();
                    }
                } else {
                    // handle error
                }
            }
        }

        request.send(args);
    };
        
    function updatePage() {
        parent.frames[0].location.href="/ttt-java/tictactoe?action=start";
    }
        
    function reportWinner(response) {
        //alert("reportWinner invoked");
        document.getElementById("result").innerHTML = response;
    }
        
    function updateBoard(args) {
        //alert(args.imageLoc);
        document.images[args.position].src = args.imageLoc;
        var result = "" + args.result;
        if (result.indexOf('won') != -1) {
            reportWinner(args.result);
        }
    }
        
    function updateMessage(args) {
        document.getElementById("result").innerHTML = args;
    }
        
    function initBoard() {
        document.images["R1C1"].src = imagesPrefix + "/blank.png";
        document.images["R1C2"].src = imagesPrefix + "/blank.png";
        document.images["R1C3"].src = imagesPrefix + "/blank.png";
        document.images["R2C1"].src = imagesPrefix + "/blank.png";
        document.images["R2C2"].src = imagesPrefix + "/blank.png";
        document.images["R2C3"].src = imagesPrefix + "/blank.png";
        document.images["R3C1"].src = imagesPrefix + "/blank.png";
        document.images["R3C2"].src = imagesPrefix + "/blank.png";
        document.images["R3C3"].src = imagesPrefix + "/blank.png";
    }
        
    function setXorO() {
        request = this.getXHR();
        url = "http://localhost:8080/ttt-java/tictactoe?action=currentSymbol";
        request.open("POST", url, false);
        request.onreadystatechange = function() {
            if (request.readyState == 4) {
                if (request.status == 200) {
                    if (request.responseText) {
                        XorO = imagesPrefix + request.responseText + '.png';
                    }
                } else {
                    // handle error
                }
            }
        }

        request.send();
    }
        
    function submitOnClick() {
        var s1 = "winner";
        if (s1 == "winner")
            alert("string matched");
        else
            alert("string did not match");
        document.getElementById('result').innerHTML = 'winner';
    }
</script>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Tic Tac Toe (JSP / Java EE 5)</title>
    </head>
    <body>
        <table width="100%">
            <tr>
                <td>
                    <h1>Tic Tac Toe</h1>
                    <h3>JSP / Java EE 5</h3>
                </td>
                <td><img src="/ttt-java/images/glassfish-logo-transparent.gif"></td>
            </tr>
        </table>
        
        <form id="tictactoeForm" name="tictactoeForm">
            <table border="1">
                <% for (int row = 0; row < 3; row++) {%>
                <tr>
                    <% for (int col = 0; col < 3; col++) {%>
                    <td><img src="/ttt-java/images/blank.png" name="R<%= row %>C<%= col %>" border="0" onclick="javascript:submitForm(this);"/></td>
                    <% }%>
                </tr>
                <% }%>
            </table>
        </form>
        
        
        <div id="result"></div>
        
    </body>
</html>
